format compact;
more on;
options=optimset([],'largescale','off');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Problem 11.10 Branch and bound solution
%  uses function milp() 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A=[-6 4; -1 -1; 4 2];   %Form the relevat matrixes
b=[-15 ; -5; 31];
c=[3 -4]; % negative of the objective since maximum
ub=[inf inf];
lb=[0 0];
% Start the iterative BRANCH AND BOUND PROCESS----------------
[x cost feas]=milp(c,A,b,[],[],[0 0],[inf inf], 2, inf);
disp('Solution is')
x
disp('Objective value is')
-cost

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    Problem 11.11 Branch and bound solution
%  uses function milp() 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A=[2 -2; -2 1; 2 2];   %Form the relevat matrixes
b=[3 ; 2; 13];
c=[-2 -1]; % negative of the objective since maximum
ub=[inf inf];
lb=[0 0];
% Start the iterative BRANCH AND BOUND PROCESS----------------
[x cost feas]=milp(c,A,b,[],[],[0 0],[inf inf], 2, inf);
disp('Solution is')
x
disp('Objective value is')
-cost

pause


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%State Estimation 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Estimation problem')
% The measurement matrix including slack bus is:
H=[-5 0;
    0 -2.5;
    4 -4];
% The given measurements are:
disp('Given measurements');
z=[0.5  0.10 0.45]'
% Matrices needed for estimate are
E=(H'*H)^(-1)*H';		% Estimate matrix unnamed in class
% The estimate is found as:
xhat=E*z
% Yielding the estimated error in each measurement is:
disp('Error in each measurement using WLS');
error=z-H*xhat
disp('Objective value (squared error)');
obj=error'*error

% Now solve for an LP problem
b=z;				% Constraint vector is the measurements
c=[1 1 1 1 1 1 0 0]';	% Cost vector
A=[diag([1 1 1]) -diag([1 1 1]) H ];	% Constraint matrix
VLB=[0 0 0 0 0 0];		% Lower bounds only on u,v variables
% n=3;					% Number of equalities
% x=lp(c,A,b,VLB,[],[],n); % LP solution
x=linprog(c,[],[],A,b,VLB,inf)
% So the estimate is found as:
% disp('Bus angle estimates in degrees than in radians using WLAV');
% xhat=180/pi*x(7:8)
xhat=x(7:8);
% The error in each measurement is:
disp('Error in each measurement using WLAV');
error=z-H*xhat
disp('Objective value');
obj=c'*x

% Show other plausible solutions
disp('Other plausible solutions using WLAV');
disp('Errors from estimate using first two measurements');
xhat=H(1:2,:)^(-1)*z(1:2)
error=z-H*xhat
disp('Errors from estimate using last two measurements');
xhat=H(2:3,:)^(-1)*z(2:3)
error=z-H*xhat

% Now add a measurement, meas. matrix including slack bus is:
disp('Now add an injection measurement');
H=[-5 0;
     0 -2.5;
     4 -4;
 	 9 -4];
% The given measurements are:
disp('Given measurements');
z=[0.5  0.10 0.45  0.30]'
% Matrices needed for estimate are
E=(H'*H)^(-1)*H';		% Estimate matrix unnamed in class
% The estimate is found as:
xhat=E*z
% Error in each measurement is:
disp('Error in each measurement using WLS');
error=z-H*xhat
disp('Objective value (weighted squared error)');
obj=error'*error

% Again solve for an LP problem
b=z;					% Constraint vector is the measurements
c=[1 1 1 1 1 1 1 1 0 0 ]';	% Cost vector
A=[diag([1 1 1 1]) -diag([1 1 1 1]) H ];	% Constraint matrix
VLB=[0 0 0 0 0 0 0 0];		% Lower bounds only on u,v variables
% n=4;							% Number of equalities
% x=lp(c,A,b,VLB,[],[],n); % LP solution
x=linprog(c,[],[],A,b,VLB,inf);
% So the estimate is found as:
xhat=x(9:10)
% The error in each measurement is:
disp('Error in each measurement using WLAV');
error=z-H*xhat
disp('Objective value');
obj=c'*x

% The other plausible solutions
disp('Objective using first and second measurements');
xhat=H(1:2,:)^(-1)*z(1:2);
error=z-H*xhat;
obj=sum(abs(error))
disp('Objective using first and third measurements');
xhat=[H(1,:); H(3,:)]^(-1)*[z(1); z(3)];
error=z-H*xhat;
obj=sum(abs(error))
disp('Objective using first and fourth measurements');
xhat=[H(1,:); H(4,:)]^(-1)*[z(1); z(4)];
error=z-H*xhat;
obj=sum(abs(error))
disp('Objective using second and third measurements');
xhat=[H(2,:); H(3,:)]^(-1)*[z(2); z(3)];
error=z-H*xhat;
obj=sum(abs(error))
disp('Objective using second and fourth measurements');
xhat=[H(2,:); H(4,:)]^(-1)*[z(2); z(4)];
error=z-H*xhat;
obj=sum(abs(error))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Alarm Processing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A=zeros(11,10);             % Form the alarm event matrix
A([1,4,6,7],1)=1;
A([1,4,6,8],2)=1;
A([1 4 5 9 10],3)=1;
A([1 4 9 10],4)=1; 
A([1 3 4 9 10],5)=1; 
A([1 3 9],6)=1; 
A([9],7)=1; 
A([11],8)=1; 
A([1,2],9)=1; 
A([1],10)=1;
A=-A;           % Sign changed for max
c=ones(1,10);   % Cost function equal weightings for all events
% b vector formed based on received alarms (note - sign)
b=-ones(1,11); % If all alarms received 
b=-[0 1 0 0 0 1 0 1 1 0 1]'; % Alarms a2 a6 a8 a9 a11
lb=zeros(1,length(c));
ub=ones(1,length(c));      %Upper bounds restricted to 1 for binary emulation 
% Solve current linprog 
disp('Solution with equal weights;')
A*ones(10,1)-b';
[x]=linprog(c,A,b,[],[],lb,ub,options)
% To make the solution unique we vary the likelihood of the events
disp('Create weighting vector with almost identical costs')
c=c+0.001*rand(length(c),1)'
% We note that events 3 to 7 are equally likely to have occurred
disp('Unique binary with these costs is ');
[x]=linprog(c,A,b,[],[],lb,ub,options)



